# docs.memri.io

Memri documentation website

# Install
```
brew install hugo
```

Or on linux
```
sudo apt-get install hugo
```

clone the doc repo's
```
git clone git@gitlab.memri.io:memri/pymemri.git
```

```
git clone git@gitlab.memri.io:memri/pod.git
```

```
git clone git@gitlab.memri.io:memri/flutter-app.git
```

# Before editing
Make sure you have the latest versions of the doc repo's: `./multipull.sh``

# Run
To serve the website locally we run
```
hugo server
```
This will render all the content in the `/content` folder.

# Manually adding content
Content is located in the `/content` folder, hugo uses this folder structure to build the navigation, and uses `_index.md` files as the main page for each folder. We can create new content by adding markdown files to this folder.

# Retrieving external content
For memri, some of the content for our documentation comes from multiple repos, most notably [pod](https://gitlab.memri.io/memri/pod), [flutter application](https://gitlab.memri.io/memri/flutter-app), and [pymemri](https://gitlab.memri.io/memri/pymemri). 

We can configure external content by modifying content.yaml and running
```
python generate.py
```
this will inspect `content.yaml`, get the specified files, and write them to the content folder. An example `content.yaml` that looks like this:
```
pymemri/README.md:
  dest: pymemri/
  title: Overview

Pod/docs/HTTP_API.md: 
  dest: pod/HTTP_API.md

Pod/docs/Schema.md:
  dest: pod/
```
is convert into the following 3 files
```
content/pymemri/README.md with title "Overview"
content/pod/HTTP_API.md with title "HTTP API"
content/pod/Schema.md with title "Schema"
```

# Adding a new lib
- Add your repo to `.gitlab-ci.yml`
- Link your files in `content.yaml`
- Create the new folder in `/content`

# Deploy
To export the website as a static site, we run the following command in CI
```
hugo
```
This will generate a static website in `/public` based on the content in `/content`
