---
title: 'Items'
date: date:2018-11-28T15:14:39+10:00
weight: 4
---

<!--
#################################################
### THIS FILE WAS AUTOGENERATED! DO NOT EDIT! ###
#################################################
# file to edit: nbs/itembase.ipynb
# command to build the docs after a change: nbdev_build_docs
-->
<div class="container" id="notebook-container">
        
    
    
<div class="cell border-box-sizing code_cell rendered">
</div>
    
<div class="cell border-box-sizing text_cell rendered"><div class="inner_cell">
<div class="text_cell_render border-box-sizing rendered_html">
<p>Any data class in pymemri inherits from <a href="/component-architectures/plugins/itembase#Item"><code>Item</code></a>. It is a base class for items with some handy functionalities to create new items and edges, retrieve all edges to other items, and sync with the pod.</p>
</div>
</div>
</div>
    
    
<div class="cell border-box-sizing code_cell rendered">
<div class="output_wrapper">
<div class="output">
<div class="output_area">

<div class="output_markdown rendered_html output_subarea ">
<h2 id="Edge" class="doc_header"><code>class</code> <code>Edge</code></h2><blockquote><p><code>Edge</code>(<strong><code>source</code></strong>, <strong><code>target</code></strong>, <strong><code>_type</code></strong>, <strong><code>label</code></strong>=<em><code>None</code></em>, <strong><code>sequence</code></strong>=<em><code>None</code></em>, <strong><code>created</code></strong>=<em><code>False</code></em>, <strong><code>reverse</code></strong>=<em><code>True</code></em>)</p>
</blockquote>
<pre><code class="nbdev-code chroma">Edges makes a link between two `ItemBase` Items. You won't use this class a lot in practice, as edges are
abstracted away for normal users. When items are retrieved from the database, the edges are parsed automatically.
When you add an edge between to items within pymemri, you will often use `ItemBase.add_edge`</code></pre>
</div>
</div>
</div>
</div>
</div>
    
    
    
<div class="cell border-box-sizing code_cell rendered">
</div>
    
    
    
<div class="cell border-box-sizing code_cell rendered">
<div class="output_wrapper">
<div class="output">
<div class="output_area">

<div class="output_markdown rendered_html output_subarea ">
<h4 id="Edge.traverse" class="doc_header"><code>Edge.traverse</code></h4><blockquote><p><code>Edge.traverse</code>(<strong><code>start</code></strong>)</p>
</blockquote>
<pre><code class="nbdev-code chroma">We can traverse an edge starting from the source to the target or vice versa. In practice we often call
item.some_edge_type, which calls item.traverse(edgetype), which in turn calls this function.</code></pre>
</div>
</div>
</div>
</div>
</div>
    
    
    
<div class="cell border-box-sizing code_cell rendered">
<div class="output_wrapper">
<div class="output">
<div class="output_area">

<div class="output_markdown rendered_html output_subarea ">
<h2 id="EdgeList" class="doc_header"><code>class</code> <code>EdgeList</code></h2><blockquote><p><code>EdgeList</code>(<strong><code>items</code></strong>:<code>List</code>[<a href="/component-architectures/plugins/itembase#Edge"><code>Edge</code></a>]=<em><code>None</code></em>, <strong><code>target_type</code></strong>:<code>type</code>=<em><code>None</code></em>) :: <code>list</code></p>
</blockquote>
<pre><code class="nbdev-code chroma">Built-in mutable sequence.
If no argument is given, the constructor creates a new empty list.
The argument must be an iterable if specified.</code></pre>
</div>
</div>
</div>
</div>
</div>
    
    
    
<div class="cell border-box-sizing code_cell rendered">
</div>
    
    
    
<div class="cell border-box-sizing code_cell rendered">
<div class="output_wrapper">
<div class="output">
<div class="output_area">

<div class="output_markdown rendered_html output_subarea ">
<h2 id="Item" class="doc_header"><code>class</code> <code>Item</code></h2><blockquote><p><code>Item</code>(<strong><code>dateCreated</code></strong>:<code>datetime</code>=<em><code>None</code></em>, <strong><code>dateModified</code></strong>:<code>datetime</code>=<em><code>None</code></em>, <strong><code>dateServerModified</code></strong>:<code>datetime</code>=<em><code>None</code></em>, <strong><code>deleted</code></strong>:<code>bool</code>=<em><code>None</code></em>, <strong><code>externalId</code></strong>:<code>str</code>=<em><code>None</code></em>, <strong><code>itemDescription</code></strong>:<code>str</code>=<em><code>None</code></em>, <strong><code>starred</code></strong>:<code>bool</code>=<em><code>None</code></em>, <strong><code>version</code></strong>:<code>str</code>=<em><code>None</code></em>, <strong><code>id</code></strong>:<code>str</code>=<em><code>None</code></em>, <strong><code>importJson</code></strong>:<code>str</code>=<em><code>None</code></em>, <strong><code>pluginClass</code></strong>:<code>str</code>=<em><code>None</code></em>, <strong><code>isMock</code></strong>:<code>bool</code>=<em><code>None</code></em>, <strong><code>changelog</code></strong>:<code>list</code>=<em><code>None</code></em>, <strong><code>label</code></strong>:<code>list</code>=<em><code>None</code></em>, <strong><code>genericAttribute</code></strong>:<code>list</code>=<em><code>None</code></em>, <strong><code>measure</code></strong>:<code>list</code>=<em><code>None</code></em>, <strong><code>sharedWith</code></strong>:<code>list</code>=<em><code>None</code></em>) :: <a href="/component-architectures/plugins/itembase#ItemBase"><code>ItemBase</code></a></p>
</blockquote>
<pre><code class="nbdev-code chroma">Item is the baseclass for all of the data classes.</code></pre>
</div>
</div>
</div>
</div>
</div>
    
    
    
<div class="cell border-box-sizing code_cell rendered">
</div>
    
    
    
<div class="cell border-box-sizing code_cell rendered">
<div class="output_wrapper">
<div class="output">
<div class="output_area">

<div class="output_markdown rendered_html output_subarea ">
<h4 id="ItemBase.add_edge" class="doc_header"><code>ItemBase.add_edge</code></h4><blockquote><p><code>ItemBase.add_edge</code>(<strong><code>name</code></strong>, <strong><code>val</code></strong>)</p>
</blockquote>
<pre><code class="nbdev-code chroma">Creates an edge of type name and makes it point to val</code></pre>
</div>
</div>
</div>
</div>
</div>
    
    
    
<div class="cell border-box-sizing code_cell rendered">
<div class="output_wrapper">
<div class="output">
<div class="output_area">

<div class="output_markdown rendered_html output_subarea ">
<h4 id="ItemBase.is_expanded" class="doc_header"><code>ItemBase.is_expanded</code></h4><blockquote><p><code>ItemBase.is_expanded</code>()</p>
</blockquote>
<pre><code class="nbdev-code chroma">returns whether the node is expanded. An expanded node retrieved nodes that are
*directly* connected to it
from the pod, and stored their values via edges in the object.</code></pre>
</div>
</div>
</div>
</div>
</div>
    
<div class="cell border-box-sizing text_cell rendered"><div class="inner_cell">
<div class="text_cell_render border-box-sizing rendered_html">
<h1 id="Usage">Usage</h1>
</div>
</div>
</div>
<div class="cell border-box-sizing text_cell rendered"><div class="inner_cell">
<div class="text_cell_render border-box-sizing rendered_html">
<p>With the <a href="/component-architectures/plugins/itembase#Item"><code>Item</code></a> and <a href="/component-architectures/plugins/itembase#Edge"><code>Edge</code></a> classes we can create an item and its surrounding graph. The schema is defined in schema.py, in general we want to use the from_data staticmethod to generate new items, because it ensures that edges are linked from both the source and the target object. Let's make a new item and add it to the pod.</p>
</div>
</div>
</div>
    
    
<div class="cell border-box-sizing code_cell rendered">
<div class="input">
<div class="inner_cell">
    <div class="input_area">
<div class=" highlight hl-ipython3 chroma"><pre class="nbdev-code chroma"><span></span><span class="k">class</span> <span class="nc">MyItem</span><span class="p">(</span><span class="n">Item</span><span class="p">):</span>
    <span class="n">properties</span> <span class="o">=</span> <span class="n">Item</span><span class="o">.</span><span class="n">properties</span> <span class="o">+</span> <span class="p">[</span><span class="s2">&quot;name&quot;</span><span class="p">,</span> <span class="s2">&quot;age&quot;</span><span class="p">]</span>
    <span class="n">edges</span> <span class="o">=</span> <span class="n">Item</span><span class="o">.</span><span class="n">edges</span> <span class="o">+</span> <span class="p">[</span><span class="s2">&quot;friend&quot;</span><span class="p">]</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="p">:</span> <span class="nb">str</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">age</span><span class="p">:</span> <span class="nb">int</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span><span class="n">friend</span><span class="p">:</span> <span class="nb">list</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="o">=</span> <span class="n">name</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">age</span> <span class="o">=</span> <span class="n">age</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">friend</span> <span class="o">=</span> <span class="n">fried</span> <span class="k">if</span> <span class="n">friend</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="k">else</span> <span class="p">[]</span>
</pre></div>
    </div>
</div>
</div>
</div>
    
    
    
<div class="cell border-box-sizing code_cell rendered">
<div class="input">
<div class="inner_cell">
    <div class="input_area">
<div class=" highlight hl-ipython3 chroma"><pre class="nbdev-code chroma"><span></span><span class="kn">from</span> <span class="nn">pymemri.pod.client</span> <span class="kn">import</span> <span class="n">PodClient</span>
<span class="n">client</span> <span class="o">=</span> <span class="n">PodClient</span><span class="p">()</span>
</pre></div>
    </div>
</div>
</div>
</div>
    
    
    
<div class="cell border-box-sizing code_cell rendered">
<div class="input">
<div class="inner_cell">
    <div class="input_area">
<div class=" highlight hl-ipython3 chroma"><pre class="nbdev-code chroma"><span></span><span class="k">assert</span> <span class="n">client</span><span class="o">.</span><span class="n">add_to_schema</span><span class="p">(</span><span class="n">MyItem</span><span class="p">(</span><span class="n">name</span><span class="o">=</span><span class="s2">&quot;abc&quot;</span><span class="p">,</span> <span class="n">age</span><span class="o">=</span><span class="mi">1</span><span class="p">))</span>
</pre></div>
    </div>
</div>
</div>
</div>
    
    
    
<div class="cell border-box-sizing code_cell rendered">
<div class="input">
<div class="inner_cell">
    <div class="input_area">
<div class=" highlight hl-ipython3 chroma"><pre class="nbdev-code chroma"><span></span><span class="n">x</span> <span class="o">=</span> <span class="n">MyItem</span><span class="p">(</span><span class="n">name</span><span class="o">=</span><span class="s2">&quot;me&quot;</span><span class="p">,</span> <span class="n">age</span><span class="o">=</span><span class="mi">30</span><span class="p">)</span>
<span class="n">target</span> <span class="o">=</span> <span class="n">MyItem</span><span class="p">(</span><span class="n">name</span><span class="o">=</span><span class="s2">&quot;my friend&quot;</span><span class="p">,</span> <span class="n">age</span><span class="o">=</span><span class="mi">31</span><span class="p">)</span>
<span class="n">client</span><span class="o">.</span><span class="n">create</span><span class="p">(</span><span class="n">target</span><span class="p">)</span>
<span class="n">x</span><span class="o">.</span><span class="n">add_edge</span><span class="p">(</span><span class="s2">&quot;friend&quot;</span><span class="p">,</span> <span class="n">MyItem</span><span class="p">(</span><span class="n">name</span><span class="o">=</span><span class="s2">&quot;my friend&quot;</span><span class="p">,</span> <span class="n">age</span><span class="o">=</span><span class="mi">31</span><span class="p">))</span>
</pre></div>
    </div>
</div>
</div>
</div>
    
<div class="cell border-box-sizing text_cell rendered"><div class="inner_cell">
<div class="text_cell_render border-box-sizing rendered_html">
<p>We can now create our <code>MyItem</code>, as a side-effect of creating it, it will receive an id</p>
</div>
</div>
</div>
    
    
<div class="cell border-box-sizing code_cell rendered">
<div class="input">
<div class="inner_cell">
    <div class="input_area">
<div class=" highlight hl-ipython3 chroma"><pre class="nbdev-code chroma"><span></span><span class="nb">print</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">id</span><span class="p">)</span>
</pre></div>
    </div>
</div>
</div>
<div class="output_wrapper">
<div class="output">
<div class="output_area">
<div class="output_subarea output_stream output_stdout output_text">
<pre>None
</pre>
</div>
</div>
</div>
</div>
</div>
    
    
    
<div class="cell border-box-sizing code_cell rendered">
<div class="input">
<div class="inner_cell">
    <div class="input_area">
<div class=" highlight hl-ipython3 chroma"><pre class="nbdev-code chroma"><span></span><span class="k">assert</span> <span class="n">client</span><span class="o">.</span><span class="n">create</span><span class="p">(</span><span class="n">x</span><span class="p">)</span>
</pre></div>
    </div>
</div>
</div>
</div>
    
    
    
<div class="cell border-box-sizing code_cell rendered">
<div class="input">
<div class="inner_cell">
    <div class="input_area">
<div class=" highlight hl-ipython3 chroma"><pre class="nbdev-code chroma"><span></span><span class="nb">print</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">id</span><span class="p">)</span>
</pre></div>
    </div>
</div>
</div>
<div class="output_wrapper">
<div class="output">
<div class="output_area">
<div class="output_subarea output_stream output_stdout output_text">
<pre>a17c93d199f4128976d7eac3542b669b
</pre>
</div>
</div>
</div>
</div>
</div>
    
    
    
<div class="cell border-box-sizing code_cell rendered">
<div class="input">
<div class="inner_cell">
    <div class="input_area">
<div class=" highlight hl-ipython3 chroma"><pre class="nbdev-code chroma"><span></span><span class="n">y</span> <span class="o">=</span> <span class="n">client</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">id</span><span class="p">)</span>
</pre></div>
    </div>
</div>
</div>
</div>
    
    
    
<div class="cell border-box-sizing code_cell rendered">
<div class="input">
<div class="inner_cell">
    <div class="input_area">
<div class=" highlight hl-ipython3 chroma"><pre class="nbdev-code chroma"><span></span><span class="k">assert</span> <span class="nb">len</span><span class="p">(</span><span class="n">y</span><span class="o">.</span><span class="n">friend</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">0</span>
</pre></div>
    </div>
</div>
</div>
</div>
    
    
    
<div class="cell border-box-sizing code_cell rendered">
<div class="input">
<div class="inner_cell">
    <div class="input_area">
<div class=" highlight hl-ipython3 chroma"><pre class="nbdev-code chroma"><span></span><span class="k">assert</span> <span class="n">y</span><span class="o">.</span><span class="n">friend</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">name</span> <span class="o">==</span> <span class="s2">&quot;my friend&quot;</span>
<span class="k">assert</span> <span class="n">y</span><span class="o">.</span><span class="n">name</span> <span class="o">==</span> <span class="s2">&quot;me&quot;</span>
<span class="k">assert</span> <span class="n">y</span><span class="o">.</span><span class="n">age</span> <span class="o">==</span> <span class="mi">30</span>
<span class="c1"># One year later</span>
<span class="n">y</span><span class="o">.</span><span class="n">age</span> <span class="o">=</span> <span class="mi">31</span>
<span class="n">y</span><span class="o">.</span><span class="n">add_edge</span><span class="p">(</span><span class="s2">&quot;friend&quot;</span><span class="p">,</span> <span class="n">MyItem</span><span class="p">(</span><span class="n">name</span><span class="o">=</span><span class="s2">&quot;my friend2&quot;</span><span class="p">,</span> <span class="n">age</span><span class="o">=</span><span class="mi">29</span><span class="p">))</span>
<span class="n">y</span><span class="o">.</span><span class="n">update</span><span class="p">(</span><span class="n">client</span><span class="p">)</span>
<span class="k">assert</span> <span class="n">y</span><span class="o">.</span><span class="n">age</span> <span class="o">==</span> <span class="mi">31</span>
<span class="k">assert</span> <span class="nb">len</span><span class="p">(</span><span class="n">y</span><span class="o">.</span><span class="n">friend</span><span class="p">)</span> <span class="o">==</span> <span class="mi">2</span>
</pre></div>
    </div>
</div>
</div>
<div class="output_wrapper">
<div class="output">
<div class="output_area">
<div class="output_subarea output_stream output_stdout output_text">
<pre>updating MyItem (#a17c93d199f4128976d7eac3542b669b)
BULK: Writing 2/2 items/edges
400 Failure: JSON deserialization error payload.createEdges[0]._target: invalid type: null, expected a string at line 1 column 245
could not complete bulk action, aborting
</pre>
</div>
</div>
</div>
</div>
</div>
    
    
    
<div class="cell border-box-sizing code_cell rendered">
<div class="input">
<div class="inner_cell">
    <div class="input_area">
<div class=" highlight hl-ipython3 chroma"><pre class="nbdev-code chroma"><span></span><span class="n">y</span><span class="o">.</span><span class="n">friend</span>
</pre></div>
    </div>
</div>
</div>
<div class="output_wrapper">
<div class="output">
<div class="output_area">

<div class="output_text output_subarea output_execute_result">
<pre>[MyItem (#None), MyItem (#None)]</pre>
</div>
</div>
</div>
</div>
</div>
    
    
    
<div class="cell border-box-sizing code_cell rendered">
<div class="input">
<div class="inner_cell">
    <div class="input_area">
<div class=" highlight hl-ipython3 chroma"><pre class="nbdev-code chroma"><span></span><span class="n">y</span><span class="o">.</span><span class="n">to_json</span><span class="p">(</span><span class="n">dates</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
</pre></div>
    </div>
</div>
</div>
<div class="output_wrapper">
<div class="output">
<div class="output_area">

<div class="output_text output_subarea output_execute_result">
<pre>{&#39;id&#39;: &#39;a17c93d199f4128976d7eac3542b669b&#39;,
 &#39;deleted&#39;: False,
 &#39;name&#39;: &#39;me&#39;,
 &#39;age&#39;: 31,
 &#39;type&#39;: &#39;MyItem&#39;}</pre>
</div>
</div>
</div>
</div>
</div>
    
</div>
 
