---
title: 'Plugins'
date: date:2018-11-28T15:14:39+10:00
weight: 3
---

<!--
#################################################
### THIS FILE WAS AUTOGENERATED! DO NOT EDIT! ###
#################################################
# file to edit: nbs/plugin.pluginbase.ipynb
# command to build the docs after a change: nbdev_build_docs
-->
<div class="container" id="notebook-container">
        
    
    
<div class="cell border-box-sizing code_cell rendered">
</div>
    
    
    
<div class="cell border-box-sizing code_cell rendered">
</div>
    
    
    
<div class="cell border-box-sizing code_cell rendered">
</div>
    
    
    
<div class="cell border-box-sizing code_cell rendered">
<div class="output_wrapper">
<div class="output">
<div class="output_area">

<div class="output_markdown rendered_html output_subarea ">
<h2 id="PluginBase" class="doc_header"><code>class</code> <code>PluginBase</code></h2><blockquote><p><code>PluginBase</code>(<strong><code>pluginRun</code></strong>=<em><code>None</code></em>, <strong><code>client</code></strong>=<em><code>None</code></em>, <strong>**<code>kwargs</code></strong>)</p>
</blockquote>
<pre><code class="nbdev-code chroma">Base class for plugins</code></pre>
</div>
</div>
</div>
</div>
</div>
    
    
    
<div class="cell border-box-sizing code_cell rendered">
</div>
    
<div class="cell border-box-sizing text_cell rendered"><div class="inner_cell">
<div class="text_cell_render border-box-sizing rendered_html">
<p><a href="/component-architectures/plugins/pluginbase#PluginBase"><code>PluginBase</code></a> is the base class of all Pymemri plugins. You can either build your plugin from scratch, or start with one of our <a href="https://gitlab.memri.io/plugins/plugin-templates">Plugins Templates</a>.</p>
<p>All inheriting classes should implement:</p>
<ul>
<li><a href="/component-architectures/plugins/pluginbase#PluginBase.run"><code>PluginBase.run</code></a>,          which implements the logic of the plugin</li>
<li><a href="/component-architectures/plugins/pluginbase#PluginBase.add_to_schema"><code>PluginBase.add_to_schema</code></a>, for adding plugin specific item types to the Pod</li>
</ul>
<p>Note that both the <code>pluginRun</code> and <code>client</code> arguments are mandatory for running a plugin. When using the <a href="/component-architectures/plugins/pluginbase#run_plugin"><code>run_plugin</code></a> CLI, these are handled for you. For local development and testing, a plugin can be initialized with just a <code>client</code>, which results in a <code>RuntimeWarning</code>.</p>
</div>
</div>
</div>
<div class="cell border-box-sizing text_cell rendered"><div class="inner_cell">
<div class="text_cell_render border-box-sizing rendered_html">
<h2 id="Example-plugin">Example plugin</h2>
</div>
</div>
</div>
<div class="cell border-box-sizing text_cell rendered"><div class="inner_cell">
<div class="text_cell_render border-box-sizing rendered_html">
<p>Let's use the following plugin as an example of how we can define and run plugins.</p>
</div>
</div>
</div>
<div class="cell border-box-sizing text_cell rendered"><div class="inner_cell">
<div class="text_cell_render border-box-sizing rendered_html">
<div class="highlight"><pre class="nbdev-code chroma"><span></span><span class="kn">from</span> <span class="nn">pymemri.pod.client</span> <span class="kn">import</span> <span class="n">Dog</span>
<span class="k">class</span> <span class="nc">ExamplePlugin</span><span class="p">(</span><span class="n">PluginBase</span><span class="p">):</span>
    <span class="n">schema_classes</span> <span class="o">=</span> <span class="p">[</span><span class="n">Dog</span><span class="p">]</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">dog_name</span><span class="p">:</span> <span class="nb">str</span> <span class="o">=</span> <span class="s2">&quot;Bob&quot;</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">dog_name</span> <span class="o">=</span> <span class="n">dog_name</span>
    <span class="k">def</span> <span class="nf">run</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Started plugin run...&quot;</span><span class="p">)</span>
        <span class="n">dog</span> <span class="o">=</span> <span class="n">Dog</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">dog_name</span><span class="p">,</span> <span class="mi">10</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">client</span><span class="o">.</span><span class="n">create</span><span class="p">(</span><span class="n">dog</span><span class="p">)</span>
        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Run success!&quot;</span><span class="p">)</span>
</pre></div>
</div>
</div>
</div>
<div class="cell border-box-sizing text_cell rendered"><div class="inner_cell">
<div class="text_cell_render border-box-sizing rendered_html">
<h3 id="Authentication">Authentication</h3>
</div>
</div>
</div>
<div class="cell border-box-sizing text_cell rendered"><div class="inner_cell">
<div class="text_cell_render border-box-sizing rendered_html">
<p>Many plugins use authentication for external services that require passwords or oauth authentication. Pymemri implements some common cases, see <a href="/pymemri/plugin.authenticators.oauth.html#OAuthAuthenticator"><code>OAuthAuthenticator</code></a> or <a href="/pymemri/plugins.authenticators.password.html#PasswordAuthenticator"><code>PasswordAuthenticator</code></a>.</p>
</div>
</div>
</div>
<div class="cell border-box-sizing text_cell rendered"><div class="inner_cell">
<div class="text_cell_render border-box-sizing rendered_html">
<h2 id="Running-your-plugin-using-the-CLI">Running your plugin using the CLI</h2>
</div>
</div>
</div>
<div class="cell border-box-sizing text_cell rendered"><div class="inner_cell">
<div class="text_cell_render border-box-sizing rendered_html">
<p>Plugins can be started using the pymemri <a href="/component-architectures/plugins/pluginbase#run_plugin"><code>run_plugin</code></a> or <a href="/component-architectures/plugins/pluginbase#simulate_run_plugin_from_frontend"><code>simulate_run_plugin_from_frontend</code></a> CLI. With <a href="/component-architectures/plugins/pluginbase#run_plugin"><code>run_plugin</code></a> the plugin is invoked directly by spawning a new python process, while <a href="/component-architectures/plugins/pluginbase#simulate_run_plugin_from_frontend"><code>simulate_run_plugin_from_frontend</code></a> requests the pod to spawn a new process, docker container, or kubernetes container, which in calls <a href="/component-architectures/plugins/pluginbase#run_plugin"><code>run_plugin</code></a> (for more info see <a href="/component-architectures/plugins/pluginbase#simulate_run_plugin_from_frontend"><code>simulate_run_plugin_from_frontend</code></a>. When using <a href="/component-architectures/plugins/pluginbase#run_plugin"><code>run_plugin</code></a>, you can either pass your run arguments as parameters, or set them as environment variables. If both are set, the CLI will use the passed arguments.</p>
</div>
</div>
</div>
    
    
<div class="cell border-box-sizing code_cell rendered">
<div class="output_wrapper">
<div class="output">
<div class="output_area">

<div class="output_markdown rendered_html output_subarea ">
<h4 id="run_plugin" class="doc_header"><code>run_plugin</code></h4><blockquote><p><code>run_plugin</code>(<strong><code>pod_full_address</code></strong>:"The pod full address"=<em><code>'http://localhost:3030'</code></em>, <strong><code>plugin_run_id</code></strong>:"Run id of the plugin to be executed"=<em><code>None</code></em>, <strong><code>database_key</code></strong>:"Database key of the pod"=<em><code>None</code></em>, <strong><code>owner_key</code></strong>:"Owner key of the pod"=<em><code>None</code></em>, <strong><code>read_args_from_env</code></strong>:"Read the args from the environment"=<em><code>False</code></em>, <strong><code>metadata</code></strong>:"metadata file for the PluginRun"=<em><code>None</code></em>, <strong><code>config_file</code></strong>:"A plugin configuration, overwrites the configuration of the PluginRun"=<em><code>None</code></em>)</p>
</blockquote>
</div>
</div>
</div>
</div>
</div>
    
    
    
<div class="cell border-box-sizing code_cell rendered">
</div>
    
<div class="cell border-box-sizing text_cell rendered"><div class="inner_cell">
<div class="text_cell_render border-box-sizing rendered_html">
<p>To start a plugin on your local machine, you can use the CLI. This will create a client for you, initialize the plugin, and run the code defined in the run method of your plugin.</p>
</div>
</div>
</div>
    
    
<div class="cell border-box-sizing code_cell rendered">
<div class="input">
<div class="inner_cell">
    <div class="input_area">
<div class=" highlight hl-ipython3 chroma"><pre class="nbdev-code chroma"><span></span><span class="o">!</span>run_plugin --metadata <span class="s2">&quot;../example_plugin.json&quot;</span>
</pre></div>
    </div>
</div>
</div>
<div class="output_wrapper">
<div class="output">
<div class="output_area">
<div class="output_subarea output_stream output_stdout output_text">
<pre>reading database_key from /Users/koen/.pymemri/pod_keys/keys.json
reading owner_key from /Users/koen/.pymemri/pod_keys/keys.json
pod_full_address=http://localhost:3030
owner_key=ff371e315505e2b1146d1bff3a769c0bcaa7077fe3eb8e60506bb0281a23f7bd
writing run info to /Users/koen/.pymemri/plugins/pymemri/current_run.json
Started plugin run...
Run success!
</pre>
</div>
</div>
</div>
</div>
</div>
    
<div class="cell border-box-sizing text_cell rendered"><div class="inner_cell">
<div class="text_cell_render border-box-sizing rendered_html">
<h3 id="Plugin-configuration">Plugin configuration</h3><p>Often, plugins require some configuration for a run. For example, our <a href="/component-architectures/plugins/pluginbase#ExamplePlugin"><code>ExamplePlugin</code></a> has a <code>dog_name</code> argument, which could be different for different runs.</p>
<p>Pymemri handles plugin configuration by passing a dictionary of configuration values to the <code>__init__</code> method of the plugin. A possible configuration for the <a href="/component-architectures/plugins/pluginbase#ExamplePlugin"><code>ExamplePlugin</code></a> could be:</p>
<div class="highlight"><pre class="nbdev-code chroma"><span></span><span class="p">{</span><span class="nt">&quot;dog_name&quot;</span><span class="p">:</span> <span class="s2">&quot;Alice&quot;</span><span class="p">}</span>
</pre></div>
<p>Configuration can be passed to the <a href="/component-architectures/plugins/pluginbase#run_plugin"><code>run_plugin</code></a> CLI in two ways:</p>
<ul>
<li>Defined in the <code>PluginRun</code> item, as <code>config</code> property. This value should be a json serialized dictionary, which is deserialized and passed to the plugin by the CLI</li>
<li>Defined in a json file and passed to <a href="/component-architectures/plugins/pluginbase#run_plugin"><code>run_plugin</code></a> as a <code>--config_file</code> argument. If this option is used, the <code>config</code> property from the <code>PluginRun</code> is ignored.</li>
</ul>
</div>
</div>
</div>
<div class="cell border-box-sizing text_cell rendered"><div class="inner_cell">
<div class="text_cell_render border-box-sizing rendered_html">
<h2 id="Run-from-pod">Run from pod</h2>
</div>
</div>
</div>
<div class="cell border-box-sizing text_cell rendered"><div class="inner_cell">
<div class="text_cell_render border-box-sizing rendered_html">
<p>In production, we start plugins by making an API call to the pod, which in turn creates an environment for the plugin and starts it using docker containers, kubernetes containers or a shell script. We can start this process using the <a href="/component-architectures/plugins/pluginbase#simulate_run_plugin_from_frontend"><code>simulate_run_plugin_from_frontend</code></a> CLI. <strong>Note that when using docker, provided container name should be built within the Pod environment (e.g. <code>docker build -t pymemri .</code> for this repo), or available on the memri gitlab container repository.</strong></p>
</div>
</div>
</div>
<div class="cell border-box-sizing text_cell rendered"><div class="inner_cell">
<div class="text_cell_render border-box-sizing rendered_html">
<p><img src="/img/pymemri/running_a_plugin.svg" alt="running a plugin"></p>
</div>
</div>
</div>
    
    
<div class="cell border-box-sizing code_cell rendered">
<div class="output_wrapper">
<div class="output">
<div class="output_area">

<div class="output_markdown rendered_html output_subarea ">
<h4 id="simulate_run_plugin_from_frontend" class="doc_header"><code>simulate_run_plugin_from_frontend</code></h4><blockquote><p><code>simulate_run_plugin_from_frontend</code>(<strong><code>pod_full_address</code></strong>:"The pod full address"=<em><code>'http://localhost:3030'</code></em>, <strong><code>database_key</code></strong>:"Database key of the pod"=<em><code>None</code></em>, <strong><code>owner_key</code></strong>:"Owner key of the pod"=<em><code>None</code></em>, <strong><code>container</code></strong>:"Pod container to run frod"=<em><code>None</code></em>, <strong><code>plugin_path</code></strong>:"Plugin path"=<em><code>None</code></em>, <strong><code>metadata</code></strong>:"metadata file for the PluginRun"=<em><code>None</code></em>, <strong><code>config_file</code></strong>:"A plugin configuration, overwrites the configuration of the PluginRun"=<em><code>None</code></em>, <strong><code>account_id</code></strong>:"Account id to be used inside the plugin"=<em><code>None</code></em>)</p>
</blockquote>
</div>
</div>
</div>
</div>
</div>
    
    
    
<div class="cell border-box-sizing code_cell rendered">
</div>
    
<div class="cell border-box-sizing text_cell rendered"><div class="inner_cell">
<div class="text_cell_render border-box-sizing rendered_html">
<h3 id="Example-usage">Example usage</h3>
</div>
</div>
</div>
    
    
<div class="cell border-box-sizing code_cell rendered">
<div class="input">
<div class="inner_cell">
    <div class="input_area">
<div class=" highlight hl-ipython3 chroma"><pre class="nbdev-code chroma"><span></span><span class="o">!</span>simulate_run_plugin_from_frontend --metadata <span class="s2">&quot;../example_plugin.json&quot;</span>
</pre></div>
    </div>
</div>
</div>
<div class="output_wrapper">
<div class="output">
<div class="output_area">
<div class="output_subarea output_stream output_stdout output_text">
<pre>reading database_key from /Users/koen/.pymemri/pod_keys/keys.json
reading owner_key from /Users/koen/.pymemri/pod_keys/keys.json
pod_full_address=http://localhost:3030
owner_key=ff371e315505e2b1146d1bff3a769c0bcaa7077fe3eb8e60506bb0281a23f7bd
Created pluginrun with id BF3231bEa1FEa32a2a8ba3bF523A6CA4 on http://localhost:3030
writing run info to /Users/koen/.pymemri/plugins/pymemri/current_run.json
*Check the pod log/console for debug output.*
</pre>
</div>
</div>
</div>
</div>
</div>
    
</div>
 
