---
title: 'Plugin Templates'
date: date:2018-11-28T15:14:39+10:00
weight: 4
---

<!--
#################################################
### THIS FILE WAS AUTOGENERATED! DO NOT EDIT! ###
#################################################
# file to edit: nbs/template.formatter.ipynb
# command to build the docs after a change: nbdev_build_docs
-->
<div class="container" id="notebook-container">
        
    
    
<div class="cell border-box-sizing code_cell rendered">
</div>
    
<div class="cell border-box-sizing text_cell rendered"><div class="inner_cell">
<div class="text_cell_render border-box-sizing rendered_html">
<p>Pymemri offers a range of plugin templates to set up testing, docker and CI for you. This way, you can focus on building your plugin, and be sure it works within the Memri ecosystem.</p>
<p>All plugins are hosted on our <a href="https://gitlab.memri.io/">GitLab</a>. In order to make your own plugin from a template,</p>
<ol>
<li>Create an account on <a href="https://gitlab.memri.io/">GitLab</a></li>
<li>Create a <em>public</em> <a href="https://gitlab.memri.io/projects/new#blank_project">blank repository</a></li>
<li>Clone the repository</li>
<li>run the <a href="/component-architectures/plugins/template#plugin_from_template"><code>plugin_from_template</code></a> CLI inside the repository folder.</li>
</ol>
<p>The CLI will infer most settings for you from your git account and repository name, only a template name and optional description are required.</p>
<pre><code class="nbdev-code chroma">plugin_from_template --template classifier_plugin --description "My Classifier Plugin"</code></pre>
<p>To make sure all settings are correct, you can inspect <code>metadata.json</code>, which holds all information like your plugin name, and python package name.</p>
<hr>
<p>You can list the available templates with. All plugin templates are hosted <a href="https://gitlab.memri.io/memri/plugin-templates">here</a>.</p>
<pre><code class="nbdev-code chroma">plugin_from_template --list</code></pre>
<p>The CLI has options to customize the plugin name, package name and other aspects of your plugin. For advanced use, run:</p>
<pre><code class="nbdev-code chroma">plugin_from_template --help</code></pre>
</div>
</div>
</div>
<div class="cell border-box-sizing text_cell rendered"><div class="inner_cell">
<div class="text_cell_render border-box-sizing rendered_html">
<h3 id="Plugin-Template-CLI">Plugin Template CLI</h3><p>With the <a href="/component-architectures/plugins/template#plugin_from_template"><code>plugin_from_template</code></a> CLI, you can easily create a plugin where all CI pipelines, docker files, and test setups are configured for you. Multiple templates are available, to see the complete list use:</p>
<p><code>plugin_from_template --list_templates</code></p>
</div>
</div>
</div>
    
    
<div class="cell border-box-sizing code_cell rendered">
<div class="output_wrapper">
<div class="output">
<div class="output_area">

<div class="output_markdown rendered_html output_subarea ">
<h4 id="plugin_from_template" class="doc_header"><code>plugin_from_template</code></h4><blockquote><p><code>plugin_from_template</code>(<strong><code>list_templates</code></strong>:"List available plugin templates"=<em><code>False</code></em>, <strong><code>user</code></strong>:"Your Gitlab username"=<em><code>None</code></em>, <strong><code>repo_url</code></strong>:"The url of your empty Gitlab plugin repository"=<em><code>None</code></em>, <strong><code>plugin_name</code></strong>:"Display name of your plugin"=<em><code>None</code></em>, <strong><code>template_name</code></strong>:"Name of the template, use <code>list_templates</code> to see all available options"=<em><code>'basic'</code></em>, <strong><code>package_name</code></strong>:"Name of your plugin python package"=<em><code>None</code></em>, <strong><code>description</code></strong>:"Description of your plugin"=<em><code>None</code></em>, <strong><code>target_dir</code></strong>:"Directory to output the formatted template"=<em><code>'.'</code></em>)</p>
</blockquote>
<pre><code class="nbdev-code chroma">CLI that downloads and formats a plugin template according to the arguments, and local git repository.
Args:
    list_templates (Param, optional): If True, only list available templates. Defaults to False.
    user (Param, optional): Your GitLab username. Defaults to None.
    repo_url (Param, optional): The url of your gitlab plugin repository. Defaults to None.
    plugin_name (Param, optional): The name of your plugin. Defaults to None.
    template_name (Param, optional): The name of the template used. To list all options, see `list_templates`.
        Defaults to "basic".
    package_name (Param, optional): The name of the python package of your plugin. Inferred if left blank. Defaults to None.
    description (Param, optional): An optional plugin description. Defaults to None.
    target_dir (Param, optional): Directory where the plugin template is generated. Defaults to ".".</code></pre>
</div>
</div>
</div>
</div>
</div>
    
    
    
<div class="cell border-box-sizing code_cell rendered">
</div>
    
    
    
<div class="cell border-box-sizing code_cell rendered">
<div class="input">
<div class="inner_cell">
    <div class="input_area">
<div class=" highlight hl-ipython3 chroma"><pre class="nbdev-code chroma"><span></span><span class="o">!</span>plugin_from_template --list_templates
</pre></div>
    </div>
</div>
</div>
<div class="output_wrapper">
<div class="output">
<div class="output_area">
<div class="output_subarea output_stream output_stdout output_text">
<pre>Available templates:
basic
classifier_plugin
</pre>
</div>
</div>
</div>
</div>
</div>
    
</div>
 
