---
title: 'Create a labeled dataset'
weight: 2
---
{{< toc >}}

 # Labeling from within the Memri app

The Memri frontend comes with a built in data labeling tool, which enables you to annotate a set of personal unique data sources, like [whatsapp](https://gitlab.memri.io/memri/plugins/whatsapp), [gmail](https://gitlab.memri.io/memri/plugins/gmail), [instagram](https://gitlab.memri.io/memri/plugins/instagram), or [twitter](https://gitlab.memri.io/memri/plugins/twitter), directly after importing it. 

Downloading and then directly labeling your data makes the labeling process much more enjoyable. No need to download and prepare big datasets, install (payed) additional software, or deal with configuration. Just select your data source, label for your task, and easily import the dataset into [Pymemri]({{< ref "/component-architectures/plugins/readme" >}}).


<div style="width:80%">
	<div style="position: relative; padding-bottom: 56.25%; height: 0; overflow: hidden; width:100%;">
		<iframe src="https://www.youtube.com/embed/UjLktAH4ZZ4" style="position: absolute; top: 0; left: 0; width: 100%; height: 100%; border:0;" allowfullscreen title="Importing Whatsapp data into the pod"></iframe>
	</div>
</div>


</br>
</br>

Currently, the labeling tool, just like the rest of the Memri app, is in alpha version. As soon as the whole flow for building model has been validated, we will start adding more labeling tasks, starting with text (NER, POS-tagging, etc.) and images (image-classification, object detection, segmentation, etc.). Would you like us to prioritize the labeling task for the project you are working on? [Create or upvote an issue](https://gitlab.memri.io/memri/flutter-app/-/issues).

With your labeled dataset ready, it is time to [build a machine learning model on top of your personal data](/build_and_deploy_your_model.md)
