---
title: 'Import your data'
weight: 1
---
{{< toc >}}

Most of our *personal data* lives in siloed databases controlled by third parties. With Memri, you can import data from third party services like Gmail or Whatsapp to your Memri Pod. Once your data is in the pod, you can easily label it, and use it to build data powered applications. All your data is fully encrypted in the Pod, and is accessible with **keys that only you own**. If you are interested to learn more about the full security profile of Memri, read more at the [Memri Pod security page](../../component-architectures/pod/Security/).


# Import your data: a short walkthrough
<div style="width:100%">
	<div style="position: relative; padding-bottom: 56.25%; height: 0; overflow: hidden; width:100%;">
		<iframe src="https://www.youtube.com/embed/Fm5TLEAdSzs" style="position: absolute; top: 0; left: 0; width: 100%; height: 100%; border:0;" allowfullscreen title="Importing Whatsapp data into the pod"></iframe>
	</div>
</div>
</br>
</br>

In the [Memri app]({{< ref "/overview/quickStart" >}} "Quickstart") you can connect `datastreams` to your account. When you authenticate with one of those `datastreams`, like the `Whatsapp datastream`, your whatsapp data will be synced with the Memri Pod. In the `Apps` section of the Memri app, you can access your `inbox`, which should now show all your chats. When you connect to other messaging apps, their data will also appear in your `inbox`. You can filter by data source, or make your own custom data visualizations.



<!-- <div class="diagram">
<img src="../../img/apps_inbox.png">
</div>
</br> -->

# Next: Build your first data app
With your data in your Pod, you are ready to start using Memri to build Data Apps. If you get stuck, our team and the community are [ready to help](http://discord.gg/kRTcDtGUmr)!

There are a few paths you can take from here:

## If you're competely new to ML
The easiest way to start is to follow [step-by-step sentiment analysis app tutorial]({{< ref "/tutorials/build_a_sentiment_analysis_app" >}}).

## Build a machine learning model on your personal data
The first step is to [create a labeled dataset]({{< ref "/guides/create_a_labeled_dataset" >}}).



