---
title: "Quick start"
weight: 2
---
{{< toc >}}

# Installation
The minimal components to get started with Memri are a [Pod](../../component-architectures/pod/README) and a [Flutter front-end](../../component-architectures/frontend/README)


## 1/3 Setup your Pod

<!-- The first step is to set up your Pod -->

{{< tabs "SettingUpPod" >}}

{{< tab "Hosted" >}} 

 <div style="margin: 30px">
 Connect to <a href="https://dev.pod.memri.io">https://dev.pod.memri.io</a> during front-end setup
</div>

{{< /tab >}}

{{< tab "Using Docker" >}} 

```Shell
$ git clone -b prod https://gitlab.memri.io/memri/pod.git && cd pod
$ docker-compose up --build
```

{{< /tab >}}
{{< tab "Local build" >}}
 <div style="margin: 30px">
See <a href="../../pod/README"> POD README </a>
<!-- ](../../pod/README) -->
</div>

{{< /tab >}}
{{< /tabs >}}

## 2/3 Setup your flutter front-end
<!-- With your pod running, the second step is to connect the front-end -->

{{< tabs "SettingUpFlutter" >}}
Both options have the same privacy profile

{{< tab "Hosted" >}}
 <div style="margin: 30px">
  <a href="http://qa.app.memri.io" target="_blank">Live alpha app</a>
</div>
{{< /tab >}}

{{< tab "Local build" >}}
 <span style="margin: 30px"> Install Flutter SDK on <a href="https://docs.flutter.dev/get-started/install/macos" target="_blank">mac</a>, <a href="https://docs.flutter.dev/get-started/install/windows" target="_blank">windows</a> or <a href="https://docs.flutter.dev/get-started/install/linux" target="_blank">linux</a> </span>


```Shell
$ flutter run -d chrome --profile
```

{{< /tab >}}
{{< /tabs >}}

## 3/3 Connect your front-end and Pod
With both Pod and front-end running, we can now connect the two. **if you as using a self-hosted pod, press `Switch to developer mode` on the landing page of the app.** Now, press `Create new Account`, which creates a new account in the Pod, and links your front-end and account. With your pod and front-end connected, you are ready to start building models,

<!-- - if you are using a hosted pod, start your front-end, and press `Create new Account`
- if you are using a self-hosted pod: 

{{< tabs "Connect" >}}
Both options have the same privacy profile

{{< tab "With hosted Pod" >}}
<span style="margin: 30px">
	Start your front-end, and press `Create new Account`
</span>
{{< /tab >}}

{{< tab "With self-hosted Pod (Docker or Local build)" >}}

 <span style="margin: 30px">
 Start your front-end, press `Switch to developer mode` and press `Create new Account` 
</span>

{{< /tab >}}
{{< /tabs >}} -->


</br>

{{< button relref="guides/import_your_data" >}}Start importing your data{{< /button >}}

