---
title: CVU Editor
weight: 3
---

Memri's web client <a href="https://gitlab.memri.io/memri/browser-application">browser-application</a> comes with an integrated CVU Editor for writing & testing CVU definitions. You can start writing your code and your custom CVU definition will be rendered on the app simulator every time you save changes. 

In your web browser open [localhost:9000](http://localhost:9000) for the app + CVU Editor (playground).

Open [localhost:9000/app.html](http://localhost:9000/app.html) for just the Memri app. 

{{< button relref="webClient/" >}}
Install and run the browser-application
{{< /button >}}


### Connect to the pod
- `http://localhost:3030/` when you're running the iOS app simulator
- `<local-laptop-IP>:3030` when your device is connected over USB or over WiFi

{{< hint info >}}
If you want to run a Client without a Pod, you’ll see an option for that on the welcome screen.
{{< /hint >}}

## Basic usage

{{< columns >}}

On the navigation panel you'll see the **user defined** and the **default** CVU definitions (a list of CVU definitions for common data types, grouped by selector). 

The **default** definitions are read-only and can be used for reference, to easily copy instructions and paste them into your **user defined** ones. You can also build your CVU definitions from scratch. Read about [cascading views](../../CVULanguage/cascadingViews/) to understand how CVU definitions are merged and rendered.  

To create a new CVU definition click the plus icon at the top of the edit panel. You can start writing your code and once you save it, it will appear in the navigation pane and it will be rendered on the app simulator. 

Every time you save changes the app simulator automatically refreshes the view. 

<--->

<img class="padded" alt="cvuEditor screenshot" src="../../img/cvuEditor_screenshot01.jpg">

{{< /columns >}}


## CVU Language

The CVU language (c-view or Cascading Views) is an easy to use language that combines capabilities of HTML and CSS. It is the language we've chosen for defining the views in the Memri app. You can think of it as a language that forms the window through which you can see your personal data (stored in your [pod](../../pod)). 

{{< button  relref="../../CVULanguage" >}}
Learn more about CVU Language
{{< /button >}}


<div class="learn_more">

##### Learn more: 
- [CVU Language](../../CVULanguage)
</div>

<div class="learn_more">

##### Repositories: 
- [browser-application repostitory](https://gitlab.memri.io/memri/pod)
</div>
