---
title: Client
weight: 4
---

The client is the interface that you use to access the information on your pod. It is basically a data browser in which you can sort, search, and navigate through your data. Currently we have a [web client](webClient/) and an [iOS/macOS](iOSapp/) client app. 

Your data is encrypted during all the various stages of its use. Access to a Pod is protected by the personal key of its owner. Only a client with the correct key can access the data in the Pod. 

The client uses [CVU language](../Tools/cvuLanguageGuide/) (c-view or Cascading Views) for defining the interfaces in the app, which you can customize in the [CVU Editor](../Tools/CVUeditor/) to maximize the usefulness of your data and its resulting knowledge, or you can create your own interface for a specific use. It is an easy to use language that combines the best of HTML and CSS. Check out the [tutorials](https://blog.memri.io/cvu-language-part-1/) on customizing the UI. 


<div class="learn_more">

##### Learn more: 
{{< toc-tree >}}
</div>

<div class="learn_more">

##### Repositories: 
- [browser-application repostitory](https://gitlab.memri.io/memri/pod)
- [iOS-application repository](https://gitlab.memri.io/memri/browser-application)
</div>

<div class="gap"></div>

### Get involved in creating new CVU interfaces

Check out our tutorial on [Co-creating the interface you spend your life in!](https://blog.memri.io/cvu-language-part-1/)
