---
title: Web client
weight: 1
---

{{< hint info >}}
This is the repository for Memri's browser-application: web client and developer playground.
{{< /hint >}}

## Local build/run

You'll need [Npm](https://www.npmjs.com/get-npm) for easy installation. 

Clone the browser-application repository and install:

```shell
$ git clone https://gitlab.memri.io/memri/browser-application.git
$ cd browser-application
$ npm install
```

To start webpack dev server run:

```shell
$ npm run start
```

{{< hint info >}}
In your web browser open [localhost:9000/app.html](http://localhost:9000/app.html) for the Memri app.
{{< /hint >}}

> If pod does not allow connection, you may need to use `--disable-web-security` flag for chrome 
(Note, this flag is applied only if `--user-data-dir=someDir` is provided as well)


## CVU Editor (playground)

Memri's web client ([browser-application](https://gitlab.memri.io/memri/browser-application)) comes with an integrated [CVU Editor](CVUeditor) for writing & testing CVU definitions. You can start writing your code and your custom CVU definition will be rendered on the app simulator every time you save changes. 

{{< hint >}}
In your web browser open [localhost:9000](http://localhost:9000) for the app + CVU Editor (playground). 
{{< /hint >}}



<div class="learn_more">

##### Learn more: 
- [CVU Editor](../CVUeditor)
- [CVU Language](../../CVULanguage)
</div>

<div class="learn_more">

##### Repositories:
- [browser-application repostitory](https://gitlab.memri.io/memri/pod)
</div>
