---
title: 'Plugins'
weight: 5
---

{{< include file="description_Plugins.md" markdown="true" >}}

## Repositories & Docs
At the moment we group plugins in a repository per lanuage, and each have their own documentation:

Language | Repository | Documentation
--- | --- | ---
Python | [pyintegrators](https://gitlab.memri.io/memri/pyintegrators) | [pyintegrators.memri.io](https://pyintegrators.memri.io)
Node.js | [nodeintegrators](https://gitlab.memri.io/memri/nodeintegrators) | [pyintegrators.memri.io](https://pyintegrators.memri.io)

<div class="gap"></div>
You'll find different types of plugins depending on their purpose: 

Type | Description
:--- | :---
**Importers** | Fetch your data from external services and store it in your Pod (Gmail, WhatsApp, etc.)
**Indexers** | Enrich data with inferences (face recognition, spam detection, etc.)
**Actions** | Excecute actions (sending messages, uploading files, etc.)

## Authentication
To connect to an external service you need to do some authentication: Some services use OAuth for that, other services only allow you to directly call the service API with your credentials, which you can store in the Pod, encrypted and under your control. 

## Get creative! 
Indexers can interact with the data in your pod and make inferences to enrich it, all in a privacy preserving way. There are many interesting use cases for indexers: 
- Your messages could be labeled to be work related or private. 
- Your digital receipts could be categorized. 
- Your email could be separated in a folder structure you like (work, advertisements, newsletters, etc.).  
- You could cluster your browsing history when you are looking for that holiday home so you can find it back easily. 
- And many more.. 

## Other actions
There are also modules that excecute actions to external services without talking to the Pod. For example, sending an email or sending out an invitation. 


<div class="learn_more">

##### Check out the guides on: 
- [Creating a plugin](../Tutorials/creating_a_plugin/)
- [Ask for a plugin](../gettingStarted/contributing/)
- [Running an Indexer](https://pyintegrators.memri.io/indexers.indexer.html/#Running-your-own-indexer) | Python Plugins documentation
- [Email Importer](https://pyintegrators.memri.io/importers.EmailImporter.html) | Python Plugins Documentation
</div>


## Get involved!

We are actively building many Plugins. You're welcome to contribute on any of the [projects under development](../gettingStarted/contributing/#active-projects) or create your own Plugin!

{{< button relref="gettingStarted/contributing" >}}
Learn more about contributing to memri
{{< /button >}}
